#include "Settings.h"

void Settings::Draw() {
    ImGui::LabelText("##title-settings", "Fine grain control over the engine!");

    if (ImGui::BeginCombo("Graphics API", GraphicsAPI[selectedGfxAPI])) {
        for (int i = 0; i < 3; i++) {
            bool isSelected = i == selectedGfxAPI;
            if (ImGui::Selectable(GraphicsAPI[i], isSelected)) {
                selectedGfxAPI = i;
            }

            if (isSelected)
                ImGui::SetItemDefaultFocus();
        }

        ImGui::EndCombo();
    }

    ImGui::NewLine();

    if (ImGui::BeginCombo("Physics Engine", PhysicsEngine[selectedPhysicsEngine])) {
        for (int i = 0; i < 2; i++) {
            bool isSelected = i == selectedPhysicsEngine;
            if (ImGui::Selectable(PhysicsEngine[i], isSelected)) {
                selectedGfxAPI = i;
            }

            if (isSelected)
                ImGui::SetItemDefaultFocus();
        }

        ImGui::EndCombo();
    }

    ImGui::InputFloat3("Gravity", glm::value_ptr(Gravity));

    ImGui::NewLine();
    if (ImGui::Button("Show Advanced options ")) {
        ShowAdvancedOptions = !ShowAdvancedOptions;
    }

    if (ShowAdvancedOptions)
    {
        ImGui::Checkbox("Debug Engine", &DebugEngine);

    }
}