#pragma once
#include "YoggieEngine.h"
#include "LayerStack.h"


namespace YoggieEngine {

	class Application {
	public:
		Application(const std::string& name);
		~Application();
		virtual void Run();

		void PollEvents();
		
		void SwapBuffers();

		void GuiBegin();
		void GuiEnd();

		void PushLayer(Layer* layer);

		static void HandleKey(GLFWwindow* window, int key, int scancode, int action, int mods);


	protected:
		std::string m_AppName;
		NativeWindow* appWindow;
		
		LayerStack AppLayerstack;

	};

};
