#pragma once
#include <glm/gtx/quaternion.hpp>

namespace YoggieEngine {
	class Camera {
	public:
		Camera() {
			projection = glm::perspective(glm::radians(90.0f), 800.0f / 600.0f, 0.001f, 1000.0f);
			//projection[3][1] *= -1;
		}

		glm::mat4 getTransform() const {

			auto transform = glm::translate(glm::mat4(1.0f), Position)
				* glm::toMat4(glm::quat(Rotation))
				* glm::scale(glm::mat4(1.0f), glm::vec3(1.0f));

			return glm::inverse(transform);
		}

		glm::mat4& getProjection(float width, float height) {

			//projection[3][1] *= -1;

			return projection;

		}

		glm::vec3 Position = glm::vec3(0.0f);
		glm::vec3 Rotation = glm::vec3(0.0f);



	private:
		glm::mat4 view;
		glm::mat4 projection;


		

	};
}
