#pragma once
#include <spdlog/spdlog.h>
class Layer {

public:
	~Layer() { OnDestroy(); }
	Layer() { OnCreate(); }

	Layer(const std::string name ) 
		: Name(name) {}


	virtual void OnUpdate(){}
	virtual void OnUI(){}
	
	virtual bool OnKey(int key , int status ) {
		spdlog::info( "Key {0} , {1}", key, status);
		return false;
	}
	
	
	virtual void OnStartup(){}

	virtual void OnAttach() {}
	virtual void OnDetach() {}
	virtual void OnCreate() {}
	virtual void OnDestroy(){}

private:

	std::string Name;


};