include("libraries")
print("Using Premake version ", _PREMAKE_VERSION)

workspace "Yoggie GameEngine"
	configurations { "Debug", "Release" } 

	language "C++"
	cppdialect "C++17"
	architecture "x86_64"

	targetdir "%{wks.location}/libs/%{prj.name}/build/%{cfg.buildcfg}"
	objdir "%{wks.location}/libs/%{prj.name}/build/%{cfg.buildcfg}/intermediates/"
	
	startproject("Editor")


	defines{
		" _CRT_SECURE_NO_WARNINGS",
		"GLFW_STATIC"
	}

	filter "configurations:Debug"
			defines {"DEBUG", "_DEBUG"}
			symbols "On"

	filter "configurations:Release"
		defines {"NDEBUG", "_DEBUG"}
		optimize "On"

		

include("./YoggieEngine")
include ("./Editor")
include ("./Tests")	  

group("Other")
	include("./SandboxApp")

group("Libraries")
  include('libs/ImGui')
  include("libs/guizmo")
  include("libs/yaml-cpp")
  
 
